<template>
  <v-data-table
    id="table-to-print"
    class="container"
    :headers="headers"
    :items="ingredientStore.ingredients"
  >
    <!-- Template for top -->
    <template v-slot:top>
      <v-toolbar flat>
        <v-toolbar-title>Stock</v-toolbar-title>
        <v-divider class="mx-4" inset vertical></v-divider>
        <v-spacer></v-spacer>

        <v-btn @click="showReport">Compare</v-btn>
        <v-btn @click="showDailyReport">Daily Report</v-btn>
        <v-btn @click="showMonthlyReport">Monthly Report</v-btn>
        <v-btn @click="showYearlyReport">Yearly Report</v-btn>
        <v-btn @click="addNewIngredientDialog = true">Add New Ingredient</v-btn>
        <v-dialog v-model="reportDialog" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <span class="text-h5">Ingredient Usage Report</span>
            </v-card-title>
            <v-card-text>
              <v-data-table :headers="reportHeaders" :items="ingredientUsage"></v-data-table>
            </v-card-text>
            <v-card-actions>
              <v-btn color="blue darken-1" text @click="reportDialog = false">Close</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="addNewIngredientDialog" persistent width="1024">
          <v-card>
            <v-card-title>
              <span class="text-h5">Ingredient Profile</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model="ingredientStore.editedIngredient.name"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Name"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12" md="4">
                      <v-text-field
                        v-model.number="ingredientStore.editedIngredient.price"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Price"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-text-field
                        v-model.number="ingredientStore.editedIngredient.amount"
                        :readonly="loading"
                        :rules="[(v) => !!v || 'Field is required']"
                        class="mb-2"
                        clearable
                        label="Amount"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="12" md="4">
                      <v-file-input
                        v-model="ingredientStore.editedIngredient.files"
                        :rules="[
                          (value) => {
                            return (
                              !value ||
                              !value.length ||
                              value[0].size < 2000000 ||
                              'Image size should be less than 2 MB!'
                            )
                          }
                        ]"
                        accept="image/png, image/jpeg"
                        placeholder="Pick an image"
                        prepend-icon="mdi-camera"
                        label="Avatar"
                      ></v-file-input>
                    </v-col>
                    <v-col cols="12" sm="12" md="4">
                      <v-img
                        :src="`http://localhost:3000/images/ingredients/${ingredientStore.editedIngredient.image}`"
                        width="200"
                      ></v-img>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
              <small>*indicates required field</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Close</v-btn>
              <!-- ปุ่มปิด -->
              <v-btn color="blue-darken-1" variant="text" @click="save">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <!-- Other buttons and dialogs -->
      </v-toolbar>
    </template>
    <!-- Other template slots -->
  </v-data-table>
</template>

<script setup lang="ts">
import html2canvas from 'html2canvas'
import jsPDF from 'jspdf'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Ingredient } from '@/types/Ingredient'
import { useIngredientStore } from '@/stores/Ingredient'
import Chart from 'chart.js/auto'
const ingredientStore = useIngredientStore()
const refForm = ref(null)
const reportDialog = ref(false)
const addNewIngredientDialog = ref(false)
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price'
  },
  {
    title: 'Amount',
    key: 'amount'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

function showDailyReport() {
  const ctx = document.getElementById('dailyReportChart').getContext('2d')
  new Chart(ctx, {
    type: 'bar',
    data: {
      labels: ['Data1', 'Data2', 'Data3', 'Data4', 'Data5'],
      datasets: [
        {
          label: 'Daily Report',
          data: [12, 19, 3, 5, 2], // ข้อมูลสำหรับแสดงบนกราฟ
          backgroundColor: 'rgba(255, 99, 132, 0.2)', // สีพื้นหลังแท่งกราฟ
          borderColor: 'rgba(255, 99, 132, 1)', // สีของเส้นขอบแท่งกราฟ
          borderWidth: 1
        }
      ]
    },
    options: {
      scales: {
        y: {
          beginAtZero: true
        }
      }
    }
  })
}

function showMonthlyReport() {
  // แสดงรายงานการสั่งซื้อวัตถุดิบรายเดือน
  console.log('Showing monthly report')
}

function showYearlyReport() {
  // แสดงรายงานการสั่งซื้อวัตถุดิบรายปี
  console.log('Showing yearly report')
}

const reportHeaders = [
  { text: 'Ingredient', value: 'name' },
  { text: 'Amount Used', value: 'amountUsed' },
  { text: 'Change', value: 'change' }
]

// Function to generate the ingredient usage report
function generateReport() {
  const ingredientUsage = [] // Initialize empty array to store ingredient usage data

  // Iterate through ingredients to calculate usage
  for (const ingredient of ingredientStore.ingredients) {
    const amountUsed = ingredient.initialAmount - ingredient.amount
    const change = amountUsed >= 0 ? 'Decrease' : 'Increase'

    // Add ingredient data to the report
    ingredientUsage.push({
      name: ingredient.name,
      amountUsed: Math.abs(amountUsed), // Use absolute value for amount used
      change
    })
  }

  return ingredientUsage
}

// Function to show the report dialog
function showReport() {
  reportDialog.value = true
}

// Computed property to get the ingredient usage report
const ingredientUsage = generateReport()

function exportPDF() {
  const tableBody = document.getElementById('table-to-print').querySelector('tbody')
  const tableData = document.getElementById('table-to-print').querySelector('table')
  const imgWidth = 208
  const imgHeight = (tableData.offsetHeight * imgWidth) / tableData.offsetWidth
  html2canvas(tableBody, { width: tableData.offsetWidth, height: tableData.offsetHeight }).then(
    (canvas) => {
      const imgData = canvas.toDataURL('image/png')
      const pdf = new jsPDF('p', 'mm', 'a4')

      // Add title and additional content
      pdf.setTextColor(0, 0, 255)
      pdf.setFontSize(18)
      pdf.text('Stock Report', 10, 15)
      pdf.setTextColor(0, 0, 0)
      pdf.setFontSize(12)
      pdf.text('This report contains information about current stock status.', 10, 25)

      // Create background color for the title
      pdf.setFillColor(200, 200, 200)
      pdf.rect(10, 10, 180, 10, 'F')

      pdf.addImage(imgData, 'PNG', 10, 30, imgWidth, imgHeight)
      pdf.save('table.pdf')
    }
  )
}
function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    ingredientStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await ingredientStore.deleteIngredient()
  closeDelete()
}
async function editItem(item: Ingredient) {
  if (!item.id) return
  await ingredientStore.getIngredient(item.id)
  dialog.value = true
}
async function deleteItem(item: Ingredient) {
  if (!item.id) return
  await ingredientStore.getIngredient(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  reportDialog.value = false
  addNewIngredientDialog.value = false
  reportDialog.value = false // สามารถลบบรรทัดนี้ออกได้เนื่องจากเคยปิด Dialog แล้ว
  addNewIngredientDialog.value = false // สามารถลบบรรทัดนี้ออกได้เนื่องจากเคยปิด Dialog แล้ว
  nextTick(() => {
    ingredientStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate() // เรียกใช้ validate() ด้วย refForm
  if (!valid) return
  await ingredientStore.saveIngredient()
  closeDialog()
}

const lowamount: any = ref([])
function LowAmount() {
  for (let i = 0; i < ingredientStore.ingredients.length; i++) {
    // Fixed loop condition
    if (ingredientStore.ingredients[i].amount <= 10) {
      lowamount.value.push(ingredientStore.ingredients[i].amount)
    }
  }
}

function getColor(amount: number): string {
  if (amount <= 5) {
    return 'red'
  } else if (amount >= 10) {
    return 'green'
  } else {
    return 'Blue'
  }
}

onMounted(async () => {
  await ingredientStore.getIngredients()
})
</script>

<style scoped>
.stock-tab {
  background-color: #ff0000; /* Set background color of the tab to red */
  padding: 10px; /* Adjust background size to fit text properly */
  border-radius: 5px; /* Add border radius for a nicer look */
  color: #ffffff; /* Set text color in the tab to white */
}

.container {
  background-color: rgba(202, 174, 123, 0.582);
  padding: 20px;
}

.card {
  background-color: #ffffff;
  border-radius: 8px;
  box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
  padding: 20px;
}

.card-title {
  color: #000000;
  font-size: 1.5em;
  margin-bottom: 20px;
}

.btn {
  background-color: #ffffff;
  color: #ffffff;
  border-radius: 4px;
  padding: 10px 20px;
  text-transform: uppercase;
  font-weight: bold;
  transition: background-color 0.3s ease;
}

.btn:hover {
  background-color: #dcdde0;
}

.icon {
  color: #000000;
}

.v-data-table {
  font-size: 14px;
}

.v-col {
  margin-bottom: 15px;
}

.small-margin {
  color: #000000;
  margin-right: 10px;
}

.v-btn.primary {
  background-color: #795548;
  color: #ffffff;
}

.v-btn.primary:hover {
  background-color: #a1887f;
}

.v-data-table-header th {
  background-color: #5d4037;
  color: #ffffff;
}

.v-data-table tbody tr:nth-child(even) {
  background-color: #fafafa;
}

.amount-number {
  background-color: transparent !important;
}
</style>
